local mapInfo = {
  author = "zsgg",
  description = "",
  modtype = 3,
  name = "Terracotta Hills",
  shortname = "Terracotta",
  version = "V1.1",
  voidGround = false,
  voidWater = false,
  atmosphere = {
    fogEnd = 1,
    fogStart = 0.1,
    skyBox = "",
    cloudColor = {
      1,
      1,
      1,
    },
    fogColor = {
      0.79999999,
      0.69999999,
      0.60000001,
    },
    skyColor = {
      0.1,
      0.15000001,
      0.69999999,
    },
    sunColor = {
      1,
      1,
      1,
    },
  },
  custom = {},
  depend = {
    "Map Helper v1",
  },
  grass = {},
  lighting = {
    groundShadowDensity = 0.80000001,
    unitShadowDensity = 0.80000001,
    groundAmbientColor = {
      0.5,
      0.5,
      0.5,
    },
    groundDiffuseColor = {
      0.5,
      0.5,
      0.5,
    },
    groundSpecularColor = {
      0.1,
      0.1,
      0.1,
    },
    sunDir = {
      0,
      0.44721356,
      0.89442712,
    },
    unitAmbientColor = {
      0.40000001,
      0.40000001,
      0.40000001,
    },
    unitDiffuseColor = {
      0.69999999,
      0.69999999,
      0.69999999,
    },
    unitSpecularColor = {
      0.69999999,
      0.69999999,
      0.69999999,
    },
  },
  replace = {},
  resources = {
    detailTex = "maps/detail.png",
    splatDetailNormalDiffuseAlpha = false,
  },
  smf = {
    grassmapTex = "maps/grass.png",
    maxheight = 98.8235321,
    minheight = -50,
    smtFileName0 = "maps/idkwhatimcallingityet.smt",
  },
  teams = {
    [0] = {
      startPos = {
        x = 7,
        z = 4415,
      },
    },
    [1] = {
      startPos = {
        x = 5868,
        z = 7147,
      },
    },
    [2] = {
      startPos = {
        x = 6435,
        z = 471,
      },
    },
  },
  terrainTypes = {},
	water = {
		damage =  0,

		repeatX = 0.0,
		repeatY = 0.0,

		absorb    = { 0.012, 0.006, 0.0045 },
		basecolor = { 1.0, 1.0, 1.0 },
		mincolor  = { 1.0, 1.0, 1.0 },

		ambientFactor  = 1.3,
		diffuseFactor  = 1.0,
		specularFactor = 1.4,
		specularPower  = 40.0,

		surfacecolor  = { 0.6, 0.54, 0.86 },
		surfaceAlpha  = 0.16,
		--diffuseColor  = {0.0, 0.0, 0.0},
		specularColor = {0.5, 0.5, 0.5},
		planeColor = {0.008, 0.035, 0.00},

		fresnelMin   = 0.3,
		fresnelMax   = 0.8,
		fresnelPower = 8.0,

		reflectionDistortion = 1.0,

		blurBase      = 2.0,
		blurExponent = 1.5,

		perlinStartFreq  =  1,
		perlinLacunarity = 1,
		perlinAmplitude  =  1,
		windSpeed = 0.01, --// does nothing yet

		shoreWaves = true,
		forceRendering = false,
		
		hasWaterPlane = true,

		--// undefined == load them from resources.lua!
		--texture =       "",
		--foamTexture =   "",
		--normalTexture = "",
		--caustics = {
		--	"",
		--	"",
		--},
	},
}
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Helper

local function lowerkeys(ta)
    local fix = {}
    for i,v in pairs(ta) do
        if (type(i) == "string") then
            if (i ~= i:lower()) then
                fix[#fix+1] = i
            end
        end
        if (type(v) == "table") then
            lowerkeys(v)
        end
    end

    for i=1,#fix do
        local idx = fix[i]
        ta[idx:lower()] = ta[idx]
        ta[idx] = nil
    end
end

lowerkeys(mapInfo)

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Map Options

if (Spring) then
    local function tmerge(t1, t2)
        for i,v in pairs(t2) do
            if (type(v) == "table") then
                t1[i] = t1[i] or {}
                tmerge(t1[i], v)
            else
                t1[i] = v
            end
        end
    end

    -- make code safe in unitsync
    if (not Spring.GetMapOptions) then
        Spring.GetMapOptions = function() return {} end
    end
    function tobool(val)
        local t = type(val)
        if (t == 'nil') then
            return false
        elseif (t == 'boolean') then
            return val
        elseif (t == 'number') then
            return (val ~= 0)
        elseif (t == 'string') then
            return ((val ~= '0') and (val ~= 'false'))
        end
        return false
    end

    getfenv()["mapInfo"] = mapInfo
        local files = VFS.DirList("mapconfig/mapinfo/", "*.lua")
        table.sort(files)
        for i=1,#files do
            local newcfg = VFS.Include(files[i])
            if newcfg then
                lowerkeys(newcfg)
                tmerge(mapInfo, newcfg)
            end
        end
    getfenv()["mapInfo"] = nil
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

return mapInfo
